"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
require("./Input.css");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var Input = function Input(_ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'text' : _ref$type,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? 'Enter value' : _ref$placeholder,
    label = _ref.label,
    validation = _ref.validation,
    errorMessage = _ref.errorMessage,
    _ref$maxLength = _ref.maxLength,
    maxLength = _ref$maxLength === void 0 ? 255 : _ref$maxLength,
    _ref$showPasswordTogg = _ref.showPasswordToggle,
    showPasswordToggle = _ref$showPasswordTogg === void 0 ? false : _ref$showPasswordTogg;
  var _useState = (0, _react.useState)(''),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = (0, _react.useState)(''),
    _useState4 = _slicedToArray(_useState3, 2),
    error = _useState4[0],
    setError = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    isPasswordVisible = _useState6[0],
    setIsPasswordVisible = _useState6[1];
  var handleChange = function handleChange(e) {
    var newValue = e.target.value;
    setValue(newValue);

    // Validate the input if a validation function is provided
    if (validation && !validation(newValue)) {
      setError(errorMessage || 'Invalid input');
    } else {
      setError('');
    }
  };
  var togglePasswordVisibility = function togglePasswordVisibility() {
    setIsPasswordVisible(!isPasswordVisible);
  };
  var inputType = type === 'password' && showPasswordToggle ? isPasswordVisible ? 'text' : 'password' : type;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "custom-input"
  }, label && /*#__PURE__*/_react["default"].createElement("label", {
    className: "input-label"
  }, label), /*#__PURE__*/_react["default"].createElement("div", {
    className: "input-wrapper"
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: inputType,
    placeholder: placeholder,
    value: value,
    onChange: handleChange,
    maxLength: maxLength,
    className: "input-field ".concat(error ? 'input-error' : '')
  }), type === 'password' && showPasswordToggle && /*#__PURE__*/_react["default"].createElement("button", {
    type: "button",
    className: "password-toggle",
    onClick: togglePasswordVisibility
  }, isPasswordVisible ? 'Hide' : 'Show')), error && /*#__PURE__*/_react["default"].createElement("span", {
    className: "error-message"
  }, error));
};
var _default = exports["default"] = Input;